<?xml version="1.0" encoding="UTF-8"?>
<!-- Vektis ei sa801val 1. - 08-04-2022 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:sa="http://ei.vektis.nl/samenloop/basisschema/v1_0" xmlns:sa801="http://ei.vektis.nl/samenloop/sa801/v1_0"	xmlns:sa801val="http://ei.vektis.nl/samenloop/sa801val/v1_0" >
 	
 	<xsl:import href="rc8028.xslt"/>
 	<xsl:import href="rc8918.xslt"/>
 	<xsl:import href="rc8919.xslt"/>
 	<xsl:import href="rc8920.xslt"/>
 	<xsl:import href="rc8921.xslt"/>
 	<xsl:import href="rc8935.xslt"/>
 	<xsl:import href="rc8930.xslt"/>
 	<xsl:import href="rc8922.xslt"/>
 	<xsl:import href="rc0435.xslt"/>
 	<xsl:import href="rc0350.xslt"/>
	<xsl:import href="rc8923.xslt"/>
	<xsl:import href="rc8924.xslt"/>
	<xsl:import href="rc8925.xslt"/>
	<xsl:import href="rc8926.xslt"/>
	<xsl:import href="rc8927.xslt"/>
	<xsl:import href="rc8939.xslt"/>
	<xsl:import href="rc9002.xslt"/>
	<xsl:import href="rc9003.xslt"/>
	<xsl:import href="rc9082.xslt"/>
	<xsl:import href="rc9116.xslt"/>
	<xsl:import href="rc9117.xslt"/>
	<xsl:import href="rc9118.xslt"/>
	<xsl:import href="rc9477.xslt"/>
	
	<!-- Uitvoer is sa801val (val = validated) bericht met Retourcodes. -->
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes" />
	
	<xsl:variable name="Berichtcode" select="//sa801:Bericht/sa801:Header/sa801:Berichtcode"/> 
	<xsl:variable name="Aanmaakdatum" select="translate(//sa801:Bericht/sa801:Header/sa801:Aanmaakdatum, '-', '')"/>
	<xsl:variable name="Aanleverjaar" select="number(//sa801:Bericht/sa801:Header/sa801:Aanleverjaar)"/> 
	<xsl:variable name="Verzender" select="//sa801:Bericht/sa801:Header/sa801:Verzender"/>
	<xsl:variable name="Ontvanger" select="//sa801:Bericht/sa801:Header/sa801:Ontvanger"/>
	
	<xsl:template match="//sa801:Bericht">
		<sa801val:Bericht>
			<xsl:attribute name="xsi:schemaLocation">http://ei.vektis.nl/samenloop/sa801val/v1_0 SA801val.xsd</xsl:attribute>
			<xsl:apply-templates select="sa801:Header"/>
			<xsl:apply-templates select="sa801:Clienten"/>
			<xsl:apply-templates select="sa801:OntbrekendeVerzenders"/>
		</sa801val:Bericht>
	</xsl:template>
	
	<xsl:template match="sa801:Header">
		<sa801val:Header>
			<xsl:apply-templates select="sa801:Berichtcode" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:BerichtVersie" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:BerichtSubversie" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:BerichtSoort" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Verzender" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Ontvanger" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:AfzenderReferentienummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Aanmaakdatum" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Aanleverjaar" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:BronIDSysteem" mode="copy-if-exists"/>
  	       	<sa801val:Retourcodes>
				
				<xsl:variable name="BerichtSoort" select="sa801:BerichtSoort"/>
					
				<!-- retourcode 8028: Soort bericht ontbreekt of is onjuist -->
				<xsl:variable name="rc8028">
					<xsl:call-template name="rc8028">
						<xsl:with-param name="BerichtSoort" select="$BerichtSoort"/>
					</xsl:call-template>
				</xsl:variable>
					
				<!-- retourcode 8918: Verzender moet voorkomen en ontvanger mag niet voorkomen. -->
				<xsl:variable name="rc8918">
					<xsl:if test="$Berichtcode = '529'">
						<xsl:call-template name="rc8918">
							<xsl:with-param name="Verzender" select="$Verzender"/>
							<xsl:with-param name="Ontvanger" select="$Ontvanger"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:variable>
				
				<!-- retourcode 8919: Ontvanger moet voorkomen en verzender mag niet voorkomen.  -->
				<xsl:variable name="rc8919">
					<xsl:if test="$Berichtcode = '530'">
						<xsl:call-template name="rc8919">
							<xsl:with-param name="Verzender" select="$Verzender"/>
							<xsl:with-param name="Ontvanger" select="$Ontvanger"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:variable>
					
				<!-- retourcode 8920: Aanmaakdatum moet kleiner zijn dan of gelijk zijn aan de huidige datum. -->
				<xsl:variable name="rc8920">
					<xsl:call-template name="rc8920">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
					</xsl:call-template>
				</xsl:variable> 
				
				<!-- retourcode 8921: Aanleverjaar moet het huidige of voorgaande jaar zijn. -->
				<xsl:variable name="rc8921">
				<xsl:if test="not($Aanleverjaar = '2015') and not($Aanleverjaar = '2016')">
					<xsl:call-template name="rc8921">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar"/>
					</xsl:call-template>
					</xsl:if>
				</xsl:variable> 
				
				<!-- retourcode 8935: Aanleverjaar moet het huidige jaar zijn. -->
				<xsl:variable name="rc8935">
				<xsl:if test="not($Aanleverjaar = '2015') and not($Aanleverjaar = '2016')">
					<xsl:call-template name="rc8935">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar"/>
					</xsl:call-template>
				</xsl:if>
				</xsl:variable> 
				
				<!-- retourcode 8939: Verzender komt niet voor in aanleverlijst VECOZO. -->
				<xsl:variable name="rc8939">	
					<xsl:if test="$Berichtcode = '529'">
						<xsl:call-template name="rc8939">
							<xsl:with-param name="Verzender" select="$Verzender"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:variable>		
					
				<xsl:copy-of select="$rc8028"/>
				<xsl:copy-of select="$rc8918"/>
				<xsl:copy-of select="$rc8919"/>
				<xsl:copy-of select="$rc8920"/>
				<xsl:copy-of select="$rc8921"/>
				<xsl:copy-of select="$rc8935"/>
				<xsl:copy-of select="$rc8939"/>
					
				<!-- Wanneer de klasse correct is dan wordt een 0200 retourcode toegevoegd. -->
				<xsl:if test="$rc8028='' and $rc8918='' and $rc8919='' and $rc8920='' and $rc8921='' and $rc8935='' and $rc8939=''">
					<sa:Retourcode>0200</sa:Retourcode>
				</xsl:if>
					
			</sa801val:Retourcodes>
		</sa801val:Header>
	</xsl:template>
	
	<xsl:template match="sa801:Clienten">	
		<sa801val:Clienten>
			<xsl:apply-templates select="sa801:Client"/>
		</sa801val:Clienten>
	</xsl:template>
	
	<xsl:template match="sa801:Client">
		<sa801val:Client>
			<xsl:apply-templates select="sa801:Zorgkantoor" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Zorgverzekeraar"/>
			<xsl:apply-templates select="sa801:Bsn" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Geboortedatum" mode="copy-if-exists"/>
				
			<sa801val:Retourcodes>
				
				<!-- retourcode 8930: Zorgkantoor komt niet voor in aanleverlijst VECOZO. -->
				<xsl:variable name="rc8930">
					<xsl:if test="$Berichtcode = '529'">
						<xsl:call-template name="rc8930">
							<xsl:with-param name="Zorgkantoor" select="sa801:Zorgkantoor"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:variable>

				<!-- retourcode 8922: Zorgverzekeraar cliënt moet gelijk zijn aan ontvanger bericht. -->
				<xsl:variable name="rc8922">
					<xsl:if test="$Berichtcode = '530'">
						<xsl:call-template name="rc8922">
							<xsl:with-param name="DeclaratieUzovi" select="sa801:Zorgverzekeraar/sa:DeclaratieUzovi"/>
							<xsl:with-param name="Ontvanger" select="$Ontvanger"/>
						</xsl:call-template>
					</xsl:if>
				</xsl:variable>

				<!-- retourcode 0435: Burgerservicenummer (BSN) verzekerde ontbreekt of is onjuist.11-proef -->
				<xsl:variable name="rc0435">
					<xsl:call-template name="rc0435">
						<xsl:with-param name="Bsn" select="sa801:Bsn"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 0350: Geboortedatum moet kleiner zijn dan huidige datum. -->
				<xsl:variable name="rc0350">
					<xsl:call-template name="rc0350">
						<xsl:with-param name="Geboortedatum" select="translate(sa801:Geboortedatum, '-', '')"/>
					</xsl:call-template>
				</xsl:variable>
					
				<xsl:copy-of select="$rc8930"/>
				<xsl:copy-of select="$rc8922"/>
				<xsl:copy-of select="$rc0435"/>
				<xsl:copy-of select="$rc0350"/>
					
				<xsl:if test="$rc8930='' and $rc8922='' and $rc0435='' and $rc0350=''">
					<sa:Retourcode>0200</sa:Retourcode>
				</xsl:if>
					
				</sa801val:Retourcodes>
				
			<xsl:apply-templates select="sa801:ZzpIndicaties"/>
			
		</sa801val:Client>
	</xsl:template>
	
	<xsl:template match="sa801:Zorgverzekeraar">
		<sa801val:Zorgverzekeraar>
			<xsl:copy-of select="sa:DeclaratieUzovi"/>
			<xsl:copy-of select="sa:Labelcode"/>
		</sa801val:Zorgverzekeraar>
	</xsl:template>
		
	<xsl:template match="sa801:ZzpIndicaties">
		<sa801val:ZzpIndicaties>
			<xsl:apply-templates select="sa801:ZzpIndicatie"/>
		</sa801val:ZzpIndicaties>
	</xsl:template>
	
	<xsl:template match="sa801:ZzpIndicatie">
		<sa801val:ZzpIndicatie>
			<xsl:apply-templates select="sa801:Besluitnummer" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Grondslagen"/>
			<xsl:apply-templates select="sa801:ZzpCode" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Periode"/>
			<xsl:apply-templates select="sa801:Financiering" mode="copy-if-exists"/>
				
			<sa801val:Retourcodes>
					
				<xsl:variable name="Begindatum" select="translate(sa801:Periode/sa:Begindatum, '-', '')"/>
				<xsl:variable name="Einddatum" select="translate(sa801:Periode/sa:Einddatum, '-', '')"/>
				
				<!-- retourcode 8923: Einddatum ZZP indicatie moet groter zijn dan of gelijk zijn aan begindatum ZZP indicatie. -->
				<xsl:variable name="rc8923">
					<xsl:call-template name="rc8923">
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 8924: Periode ZZP indicatie en aanleverjaar moeten elkaar gedeeltelijk overlappen. -->
				<xsl:variable name="rc8924">
					<xsl:call-template name="rc8924">
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar "/>
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 9002: Einddatum indicatie/zorg mag niet groter zijn dan de laatste dag van de aanleverperiode + 1 maand. -->
				<xsl:variable name="rc9002">
					<xsl:call-template name="rc9002">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 9116: Periode ZZPIndicatie moet binnen het aanleverjaar vallen. -->
				<xsl:variable name="rc9116">
					<xsl:call-template name="rc9116">
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 9118: Einddatum ZZP indicatie moet gevuld zijn bij afgesloten aanleverjaar. -->
				<xsl:variable name="rc9118">
					<xsl:call-template name="rc9118">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>		
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar"/>
						<xsl:with-param name="EinddatumZzp" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<xsl:copy-of select="$rc8923"/>
				<xsl:copy-of select="$rc8924"/>
				<xsl:copy-of select="$rc9002"/>
				<xsl:copy-of select="$rc9116"/>
				<xsl:copy-of select="$rc9118"/>
				
				<xsl:if test="$rc8923='' and $rc8924='' and $rc9002='' and $rc9116='' and $rc9118='' ">
					<sa:Retourcode>0200</sa:Retourcode>
				</xsl:if>
					
				</sa801val:Retourcodes>
				
			<xsl:apply-templates select="sa801:Zorgleveringen"/>
			
		</sa801val:ZzpIndicatie>
	</xsl:template>
	
	<xsl:template match="sa801:Grondslagen">
		<sa801val:Grondslagen>
			<xsl:copy-of select="sa:Grondslag01"/>
			<xsl:copy-of select="sa:Grondslag02"/>
		</sa801val:Grondslagen>
	</xsl:template>
	
	<xsl:template match="sa801:Periode">
		<sa801val:Periode>
			<xsl:copy-of select="sa:Begindatum"/>
			<xsl:copy-of select="sa:Einddatum"/>
		</sa801val:Periode>
	</xsl:template>
	
	<xsl:template match="sa801:Zorgleveringen">
		<sa801val:Zorgleveringen>
			<xsl:apply-templates select="sa801:Zorglevering"/>
		</sa801val:Zorgleveringen>
	</xsl:template>
	
	<xsl:template match="sa801:Zorglevering">
		<sa801val:Zorglevering>
			<xsl:apply-templates select="sa801:ZzpCode" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Zorgaanbieder" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:Periode"/>
			<xsl:apply-templates select="sa801:Behandeling"/>
				
			<sa801val:Retourcodes>
					
				<xsl:variable name="BegindatumZzp" select="translate(../../sa801:Periode/sa:Begindatum, '-', '')"/>
				<xsl:variable name="EinddatumZzp" select="translate(../../sa801:Periode/sa:Einddatum, '-', '')"/>
				<xsl:variable name="Begindatum" select="translate(sa801:Periode/sa:Begindatum, '-', '')"/>
				<xsl:variable name="Einddatum" select="translate(sa801:Periode/sa:Einddatum, '-', '')"/>
				<xsl:variable name="Behandeling" select="sa801:Behandeling"/>
				
				<!-- retourcode 8925: Einddatum zorg moet groter zijn dan of gelijk zijn aan begindatum zorg. -->
				<xsl:variable name="rc8925">
					<xsl:call-template name="rc8925">
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 8926: Begindatum zorg moet groter zijn dan of gelijk zijn aan begindatum ZZP Indicatie. -->
				<xsl:variable name="rc8926">
					<xsl:call-template name="rc8926">
						<xsl:with-param name="BegindatumZorg" select="$Begindatum"/>
						<xsl:with-param name="BegindatumZzp" select="$BegindatumZzp"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 8927: Einddatum zorg moet kleiner zijn dan of gelijk zijn aan einddatum ZZP Indicatie. -->
				<xsl:variable name="rc8927">
					<xsl:call-template name="rc8927">
						<xsl:with-param name="EinddatumZorg" select="$Einddatum"/>
						<xsl:with-param name="EinddatumZzp" select="$EinddatumZzp"/>
					</xsl:call-template>
				</xsl:variable>
				
				<!-- retourcode 9003: Einddatum zorg mag niet groter zijn dan de laatste dag van de aanleverperiode + 1 maand. -->
				<xsl:variable name="rc9003">
					<xsl:call-template name="rc9003">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
					
				<!-- retourcode 9082: Periode zorglevering en aanleverjaar moeten elkaar gedeeltelijk overlappen. -->
				<xsl:variable name="rc9082">
					<xsl:call-template name="rc9082">
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar "/>
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Einddatum" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
					
				<!-- retourcode 9117: Einddatum zorg moet gevuld zijn bij afgesloten aanleverjaar. -->
				<xsl:variable name="rc9117">
					<xsl:call-template name="rc9117">
						<xsl:with-param name="Aanmaakdatum" select="$Aanmaakdatum"/>		
						<xsl:with-param name="Aanleverjaar" select="$Aanleverjaar"/>
						<xsl:with-param name="EinddatumZorg" select="$Einddatum"/>
					</xsl:call-template>
				</xsl:variable>
					
				<!-- retourcode 9477: Indien berichtcode = '529' dan moet zorglevering voorkomen. -->
				<xsl:variable name="rc9477">
					<xsl:call-template name="rc9477">
						<xsl:with-param name="Berichtcode" select="$Berichtcode"/>
						<xsl:with-param name="Begindatum" select="$Begindatum"/>
						<xsl:with-param name="Behandeling" select="$Behandeling"/>
					</xsl:call-template>
				</xsl:variable>
				
				<xsl:copy-of select="$rc8925"/>
				<xsl:copy-of select="$rc8926"/>
				<xsl:copy-of select="$rc8927"/>
				<xsl:copy-of select="$rc9003"/>
				<xsl:copy-of select="$rc9082"/>
				<xsl:copy-of select="$rc9117"/>
				<xsl:copy-of select="$rc9477"/>
					
				<xsl:if test="$rc8925='' and $rc8926='' and $rc8927='' and $rc9003='' and $rc9082='' and $rc9117='' and $rc9477=''">
					<sa:Retourcode>0200</sa:Retourcode>
				</xsl:if>
					
				</sa801val:Retourcodes>
				
			</sa801val:Zorglevering>
	</xsl:template>
		
	<xsl:template match="sa801:Behandeling">
		<sa801val:Behandeling>
			<xsl:apply-templates select="sa801:BerichtType" mode="copy-if-exists"/>
			<xsl:apply-templates select="sa801:MetBehandeling" mode="copy-if-exists"/>
		</sa801val:Behandeling>
	</xsl:template>
			
	<xsl:template match="sa801:OntbrekendeVerzenders">
		<sa801val:OntbrekendeVerzenders>
			<xsl:apply-templates select="sa801:OntbrekendeVerzender" mode="copy-if-exists"/>
			
			<sa801val:Retourcodes>
				<!-- retourcode 8938: Ontbrekende verzender mag niet voorkomen. -->
				<xsl:if test="$Berichtcode = '529'">	
					<sa:Retourcode>8938</sa:Retourcode>
				</xsl:if>
					
				<xsl:if test="$Berichtcode = '530'">
					<xsl:variable name="rc8939">
						<xsl:for-each select="sa801:OntbrekendeVerzender">
						<!-- retourcode 8939: Verzender komt niet voor in aanleverlijst VECOZO. -->
							
							<xsl:call-template name="rc8939">
								<xsl:with-param name="Verzender" select="text()"/>
							</xsl:call-template>
						
						</xsl:for-each>	
					</xsl:variable>
				
					<xsl:copy-of select="$rc8939"/>
					
					<xsl:if test="$rc8939=''">
						<sa:Retourcode>0200</sa:Retourcode>
					</xsl:if>
					
				</xsl:if>
				
			</sa801val:Retourcodes>		
			
		</sa801val:OntbrekendeVerzenders>
	</xsl:template>
	
	<!-- Copy template: als een enkel element voorkomt is, wordt deze gekopieerd in de opgegeven namespace -->
	<xsl:template match="*" mode="copy-if-exists">
		<xsl:param name="NameSpacePrefix" select="'sa801val:'"/>
		<xsl:if test=".">
			<xsl:element name="{concat($NameSpacePrefix,local-name())}">
				<xsl:value-of select="text()"/>
			</xsl:element>
		</xsl:if>
	</xsl:template>

</xsl:stylesheet>
