<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sa="http://ei.vektis.nl/samenloop/basisschema/v1_0">

	<!-- retourcode 9002: Einddatum ZZP indicatie mag niet groter zijn dan de laatste dag van de aanleverperiode + 1 maand.  -->
	
	<xsl:template name="rc9002">

		<xsl:param name="Aanmaakdatum"/>
		<xsl:param name="Einddatum"/>
		
		<!-- Bepalen peildatum voor rc9002/9003: eerste dag aanmaakdatum + 2 maanden. -->
	<xsl:variable name="Peilmaand" select="(substring($Aanmaakdatum,5,2))" />
	
	<xsl:if test="normalize-space($Peilmaand) = '11'">
		<xsl:variable name="Peiljaar" select="(substring($Aanmaakdatum,1,4) + 1)" />
		<xsl:variable name="Peildatum" select="concat($Peiljaar,'0101')" />
		<xsl:if test="not(normalize-space($Einddatum)='')">
			<xsl:if test="normalize-space($Einddatum) &gt;= normalize-space($Peildatum)">
				<sa:Retourcode>9002</sa:Retourcode>
			</xsl:if>
		</xsl:if>
	</xsl:if>
	
	<xsl:if test="normalize-space($Peilmaand) = '12'">
		<xsl:variable name="Peiljaar" select="(substring($Aanmaakdatum,1,4) + 1)" />
		<xsl:variable name="Peildatum" select="concat($Peiljaar,'0201')" />
		<xsl:if test="not(normalize-space($Einddatum)='')">
			<xsl:if test="normalize-space($Einddatum) &gt;= normalize-space($Peildatum)">
				<sa:Retourcode>9002</sa:Retourcode>
			</xsl:if>
		</xsl:if>
	</xsl:if>
	
	<xsl:if test="normalize-space($Peilmaand) &lt;= '10'">
		<xsl:variable name="Peilperiode" select="(substring($Aanmaakdatum,1,6) + 2)" />
		<xsl:variable name="Peildatum" select="concat($Peilperiode,'01')" />
		<xsl:if test="not(normalize-space($Einddatum)='')">
			<xsl:if test="normalize-space($Einddatum) &gt;= normalize-space($Peildatum)">
				<sa:Retourcode>9002</sa:Retourcode>
			</xsl:if>
		</xsl:if>		
	</xsl:if>
			
	</xsl:template>
</xsl:stylesheet>