<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sa="http://ei.vektis.nl/samenloop/basisschema/v1_0">

	<!-- retourcode 9082: Periode zorglevering moet binnen het aanleverjaar vallen.   -->
	
	<xsl:template name="rc9082">

		<xsl:param name="Aanleverjaar"/>
		<xsl:param name="Begindatum"/>
		<xsl:param name="Einddatum"/>
		
		<xsl:variable name="BeginAanleverjaar" select="concat($Aanleverjaar,'0101')" />
		<xsl:variable name="EindAanleverjaar" select="concat($Aanleverjaar,'1231')" />
		
		<xsl:if test="normalize-space($Begindatum) &lt; normalize-space($BeginAanleverjaar)">
			<sa:Retourcode>9082</sa:Retourcode>
		</xsl:if>
		
		<xsl:if test="normalize-space($Begindatum) &gt; normalize-space($EindAanleverjaar)">
			<sa:Retourcode>9082</sa:Retourcode>
		</xsl:if>
		
		<xsl:if test="not(normalize-space($Einddatum)='')">
			<xsl:if test="normalize-space($Einddatum) &lt; normalize-space($BeginAanleverjaar)">
				<sa:Retourcode>9082</sa:Retourcode>
			</xsl:if>
			
			<xsl:if test="normalize-space($Einddatum) &gt; normalize-space($EindAanleverjaar)">
				<sa:Retourcode>9082</sa:Retourcode>
			</xsl:if>
		</xsl:if>
			
	</xsl:template>
</xsl:stylesheet>